Index: /branches/2521_ProblemRefactoring/HeuristicLab.Problems.PTSP/3.3/PTSPData.cs
===================================================================
--- /branches/2521_ProblemRefactoring/HeuristicLab.Problems.PTSP/3.3/PTSPData.cs	(revision 17253)
+++ /branches/2521_ProblemRefactoring/HeuristicLab.Problems.PTSP/3.3/PTSPData.cs	(revision 17253)
@@ -0,0 +1,341 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using HEAL.Attic;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+using HeuristicLab.Problems.Instances;
+using HeuristicLab.Problems.TravelingSalesman;
+
+namespace HeuristicLab.Problems.PTSP {
+  [StorableType("dd2d0ecc-372e-46f1-846f-fb4ca2afa124")]
+  public interface IProbabilisticTSPData : ITSPData {
+    double GetProbability(int city);
+    new PTSPData Export();
+  }
+
+  [Item("Matrix-based p-TSP Data", "p-TSP that is representd by a distance matrix.")]
+  [StorableType("30ebade1-d28c-4e45-b195-c7fa32a15df5")]
+  public class MatrixProbabilisticTSPData : MatrixTSPData, IProbabilisticTSPData {
+    [Storable] public PercentArray Probabilities { get; protected set; }
+
+    [StorableConstructor]
+    protected MatrixProbabilisticTSPData(StorableConstructorFlag _) : base(_) { }
+    protected MatrixProbabilisticTSPData(MatrixProbabilisticTSPData original, Cloner cloner) : base(original, cloner) {
+      Probabilities = original.Probabilities;
+    }
+    public MatrixProbabilisticTSPData() {
+      Name = PTSPDefaultInstance.Name;
+      Matrix = PTSPDefaultInstance.Distances;
+      Probabilities = PTSPDefaultInstance.Probabilities;
+      DisplayCoordinates = PTSPDefaultInstance.Coordinates;
+    }
+    public MatrixProbabilisticTSPData(string name, double[,] matrix, double[] probabilities, double[,] coordinates = null)
+      : base(name, matrix, coordinates) {
+      Probabilities = new PercentArray(probabilities, @readonly: true);
+    }
+    public MatrixProbabilisticTSPData(string name, DoubleMatrix matrix, PercentArray probabilities, DoubleMatrix coordinates = null)
+      : base(name, matrix, coordinates) {
+      Probabilities = probabilities.AsReadOnly();
+    }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new MatrixProbabilisticTSPData(this, cloner);
+    }
+
+    public double GetProbability(int city) => Probabilities[city];
+
+    public new PTSPData Export() {
+      return new PTSPData() {
+        Name = name,
+        Description = description,
+        Coordinates = DisplayCoordinates?.CloneAsMatrix(),
+        Dimension = Matrix.Rows,
+        DistanceMeasure = DistanceMeasure.Direct,
+        Distances = Matrix.CloneAsMatrix(),
+        Probabilities = Probabilities.CloneAsArray()
+      };
+    }
+  }
+
+  [Item("Euclidean p-TSP Data", "p-TSP that is represented by coordinates in an Euclidean plane.")]
+  [StorableType("8d4cf257-9013-4746-bc6c-37615954c3fb")]
+  public class EuclideanPTSPData : EuclideanTSPData, IProbabilisticTSPData {
+    [Storable] public PercentArray Probabilities { get; protected set; }
+
+    [StorableConstructor]
+    protected EuclideanPTSPData(StorableConstructorFlag _) : base(_) { }
+    protected EuclideanPTSPData(EuclideanPTSPData original, Cloner cloner) : base(original, cloner) {
+      Probabilities = original.Probabilities;
+    }
+    public EuclideanPTSPData() : base() {
+      Name = PTSPDefaultInstance.Name;
+      Coordinates = PTSPDefaultInstance.Coordinates;
+      Probabilities = PTSPDefaultInstance.Probabilities;
+      Rounding = DistanceRounding.Midpoint;
+    }
+    public EuclideanPTSPData(string name, double[,] coordinates, double[] probabilities, DistanceRounding rounding = DistanceRounding.None)
+      : base(name, coordinates) {
+      if (coordinates.GetLength(0) != probabilities.Length) throw new InvalidOperationException("Number of cities is ambiguous between " + nameof(coordinates) + " and " + nameof(probabilities) + ".");
+      Probabilities = new PercentArray(probabilities, @readonly: true);
+    }
+    public EuclideanPTSPData(string name, DoubleMatrix coordinates, PercentArray probabilities, DistanceRounding rounding = DistanceRounding.None)
+      : base(name, coordinates, rounding) {
+      if (coordinates.Rows != probabilities.Length) throw new InvalidOperationException("Number of cities is ambiguous between " + nameof(coordinates) + " and " + nameof(probabilities) + ".");
+      Probabilities = probabilities.AsReadOnly();
+    }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new EuclideanPTSPData(this, cloner);
+    }
+
+    public double GetProbability(int city) => Probabilities[city];
+
+    public new PTSPData Export() {
+      var data = new PTSPData() {
+        Name = name,
+        Description = description,
+        Coordinates = Coordinates.CloneAsMatrix(),
+        Probabilities = Probabilities.CloneAsArray(),
+        Dimension = Coordinates.Rows,
+      };
+      switch (Rounding) {
+        case DistanceRounding.None: data.DistanceMeasure = DistanceMeasure.Euclidean; break;
+        case DistanceRounding.Midpoint: data.DistanceMeasure = DistanceMeasure.RoundedEuclidean; break;
+        case DistanceRounding.Ceiling: data.DistanceMeasure = DistanceMeasure.UpperEuclidean; break;
+      }
+      return data;
+    }
+  }
+
+  [Item("Geo p-TSP Data", "p-TSP that is represented by geo coordinates.")]
+  [StorableType("b175e0be-5706-4c44-b3f0-dcb948d5c47a")]
+  public class GeoPTSPData : GeoTSPData, IProbabilisticTSPData {
+    [Storable] public PercentArray Probabilities { get; protected set; }
+
+    [StorableConstructor]
+    protected GeoPTSPData(StorableConstructorFlag _) : base(_) { }
+    protected GeoPTSPData(GeoPTSPData original, Cloner cloner)
+      : base(original, cloner) {
+      Probabilities = original.Probabilities;
+    }
+    public GeoPTSPData() : base() {
+      Name = PTSPDefaultInstance.Name;
+      Coordinates = PTSPDefaultInstance.Coordinates;
+      Probabilities = PTSPDefaultInstance.Probabilities;
+    }
+    public GeoPTSPData(string name, double[,] coordinates, double[] probabilities)
+      : base(name, coordinates) {
+      if (coordinates.GetLength(0) != probabilities.Length) throw new InvalidOperationException("Number of cities is ambiguous between " + nameof(coordinates) + " and " + nameof(probabilities) + ".");
+      Probabilities = new PercentArray(probabilities, @readonly: true);
+    }
+    public GeoPTSPData(string name, DoubleMatrix coordinates, PercentArray probabilities)
+      : base(name, coordinates) {
+      if (coordinates.Rows != probabilities.Length) throw new InvalidOperationException("Number of cities is ambiguous between " + nameof(coordinates) + " and " + nameof(probabilities) + ".");
+      Probabilities = probabilities.AsReadOnly();
+    }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new GeoPTSPData(this, cloner);
+    }
+
+    public double GetProbability(int city) => Probabilities[city];
+
+    public new PTSPData Export() {
+      return new PTSPData() {
+        Name = name,
+        Description = description,
+        Coordinates = Coordinates.CloneAsMatrix(),
+        Probabilities = Probabilities.CloneAsArray(),
+        Dimension = Coordinates.Rows,
+        DistanceMeasure = DistanceMeasure.Geo,
+      };
+    }
+  }
+
+  [Item("ATT p-TSP Data", "p-TSP that is represented by ATT distance.")]
+  [StorableType("7a2aa605-58d2-4533-a763-3d474e185460")]
+  public class AttPTSPData : AttTSPData, IProbabilisticTSPData {
+    [Storable] public PercentArray Probabilities { get; protected set; }
+
+    [StorableConstructor]
+    protected AttPTSPData(StorableConstructorFlag _) : base(_) { }
+    protected AttPTSPData(AttPTSPData original, Cloner cloner)
+      : base(original, cloner) {
+      Probabilities = original.Probabilities;
+    }
+    public AttPTSPData() : base() {
+      Name = PTSPDefaultInstance.Name;
+      Coordinates = PTSPDefaultInstance.Coordinates;
+      Probabilities = PTSPDefaultInstance.Probabilities;
+    }
+    public AttPTSPData(string name, double[,] coordinates, double[] probabilities)
+      : base(name, coordinates) {
+      if (coordinates.GetLength(0) != probabilities.Length) throw new InvalidOperationException("Number of cities is ambiguous between " + nameof(coordinates) + " and " + nameof(probabilities) + ".");
+      Probabilities = new PercentArray(probabilities, @readonly: true);
+    }
+    public AttPTSPData(string name, DoubleMatrix coordinates, PercentArray probabilities)
+      : base(name, coordinates) {
+      if (coordinates.Rows != probabilities.Length) throw new InvalidOperationException("Number of cities is ambiguous between " + nameof(coordinates) + " and " + nameof(probabilities) + ".");
+      Probabilities = probabilities.AsReadOnly();
+    }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new AttPTSPData(this, cloner);
+    }
+
+    public double GetProbability(int city) => Probabilities[city];
+
+    public new PTSPData Export() {
+      return new PTSPData() {
+        Name = name,
+        Description = description,
+        Coordinates = Coordinates.CloneAsMatrix(),
+        Probabilities = Probabilities.CloneAsArray(),
+        Dimension = Coordinates.Rows,
+        DistanceMeasure = DistanceMeasure.Att,
+      };
+    }
+  }
+
+  [Item("Manhattan p-TSP Data", "p-TSP that is represented by Manhattan distance.")]
+  [StorableType("cc43d1db-3da9-4d6e-becb-6b475b42fc59")]
+  public class ManhattanPTSPData : ManhattanTSPData, IProbabilisticTSPData {
+    [Storable] public PercentArray Probabilities { get; protected set; }
+
+    [StorableConstructor]
+    protected ManhattanPTSPData(StorableConstructorFlag _) : base(_) { }
+    protected ManhattanPTSPData(ManhattanPTSPData original, Cloner cloner)
+      : base(original, cloner) {
+      Probabilities = original.Probabilities;
+    }
+    public ManhattanPTSPData() : base() {
+      Name = PTSPDefaultInstance.Name;
+      Coordinates = PTSPDefaultInstance.Coordinates;
+      Probabilities = PTSPDefaultInstance.Probabilities;
+    }
+    public ManhattanPTSPData(string name, double[,] coordinates, double[] probabilities)
+      : base(name, coordinates) {
+      if (coordinates.GetLength(0) != probabilities.Length) throw new InvalidOperationException("Number of cities is ambiguous between " + nameof(coordinates) + " and " + nameof(probabilities) + ".");
+      Probabilities = new PercentArray(probabilities, @readonly: true);
+    }
+    public ManhattanPTSPData(string name, DoubleMatrix coordinates, PercentArray probabilities)
+      : base(name, coordinates) {
+      if (coordinates.Rows != probabilities.Length) throw new InvalidOperationException("Number of cities is ambiguous between " + nameof(coordinates) + " and " + nameof(probabilities) + ".");
+      Probabilities = probabilities.AsReadOnly();
+    }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new ManhattanPTSPData(this, cloner);
+    }
+
+    public double GetProbability(int city) => Probabilities[city];
+
+    public new PTSPData Export() {
+      return new PTSPData() {
+        Name = name,
+        Description = description,
+        Coordinates = Coordinates.CloneAsMatrix(),
+        Probabilities = Probabilities.CloneAsArray(),
+        Dimension = Coordinates.Rows,
+        DistanceMeasure = DistanceMeasure.Manhattan,
+      };
+    }
+  }
+
+  [Item("Maximum p-TSP Data", "p-TSP that is represented by maximum absolute distance in either the x or y coordinates.")]
+  [StorableType("82e9cde2-a942-403a-80ff-8deae4fa8214")]
+  public class MaximumPTSPData : MaximumTSPData, IProbabilisticTSPData {
+    [Storable] public PercentArray Probabilities { get; protected set; }
+
+    [StorableConstructor]
+    protected MaximumPTSPData(StorableConstructorFlag _) : base(_) { }
+    protected MaximumPTSPData(MaximumPTSPData original, Cloner cloner)
+      : base(original, cloner) {
+      Probabilities = original.Probabilities;
+    }
+    public MaximumPTSPData() : base() {
+      Name = PTSPDefaultInstance.Name;
+      Coordinates = PTSPDefaultInstance.Coordinates;
+      Probabilities = PTSPDefaultInstance.Probabilities;
+    }
+    public MaximumPTSPData(string name, double[,] coordinates, double[] probabilities)
+      : base(name, coordinates) {
+      if (coordinates.GetLength(0) != probabilities.Length) throw new InvalidOperationException("Number of cities is ambiguous between " + nameof(coordinates) + " and " + nameof(probabilities) + ".");
+      Probabilities = new PercentArray(probabilities, @readonly: true);
+    }
+    public MaximumPTSPData(string name, DoubleMatrix coordinates, PercentArray probabilities)
+      : base(name, coordinates) {
+      if (coordinates.Rows != probabilities.Length) throw new InvalidOperationException("Number of cities is ambiguous between " + nameof(coordinates) + " and " + nameof(probabilities) + ".");
+      Probabilities = probabilities.AsReadOnly();
+    }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new MaximumPTSPData(this, cloner);
+    }
+
+    public double GetProbability(int city) => Probabilities[city];
+
+    public new PTSPData Export() {
+      return new PTSPData() {
+        Name = name,
+        Description = description,
+        Coordinates = Coordinates.CloneAsMatrix(),
+        Probabilities = Probabilities.CloneAsArray(),
+        Dimension = Coordinates.Rows,
+        DistanceMeasure = DistanceMeasure.Maximum,
+      };
+    }
+  }
+
+  internal static class PTSPDefaultInstance {
+    internal static readonly DoubleMatrix Distances = new DoubleMatrix(new double[,] {
+{ 0, 100, 200, 300, 100, 141, 224, 316, 200, 224, 283, 361, 300, 316, 361, 424 },
+{ 100, 0, 100, 200, 141, 100, 141, 224, 224, 200, 224, 283, 316, 300, 316, 361 },
+{ 200, 100, 0, 100, 224, 141, 100, 141, 283, 224, 200, 224, 361, 316, 300, 316 },
+{ 300, 200, 100, 0, 316, 224, 141, 100, 361, 283, 224, 200, 424, 361, 316, 300 },
+{ 100, 141, 224, 316, 0, 100, 200, 300, 100, 141, 224, 316, 200, 224, 283, 361 },
+{ 141, 100, 141, 224, 100, 0, 100, 200, 141, 100, 141, 224, 224, 200, 224, 283 },
+{ 224, 141, 100, 141, 200, 100, 0, 100, 224, 141, 100, 141, 283, 224, 200, 224 },
+{ 316, 224, 141, 100, 300, 200, 100, 0, 316, 224, 141, 100, 361, 283, 224, 200 },
+{ 200, 224, 283, 361, 100, 141, 224, 316, 0, 100, 200, 300, 100, 141, 224, 316 },
+{ 224, 200, 224, 283, 141, 100, 141, 224, 100, 0, 100, 200, 141, 100, 141, 224 },
+{ 283, 224, 200, 224, 224, 141, 100, 141, 200, 100, 0, 100, 224, 141, 100, 141 },
+{ 361, 283, 224, 200, 316, 224, 141, 100, 300, 200, 100, 0, 316, 224, 141, 100 },
+{ 300, 316, 361, 424, 200, 224, 283, 361, 100, 141, 224, 316, 0, 100, 200, 300 },
+{ 316, 300, 316, 361, 224, 200, 224, 283, 141, 100, 141, 224, 100, 0, 100, 200 },
+{ 361, 316, 300, 316, 283, 224, 200, 224, 224, 141, 100, 141, 200, 100, 0, 100 },
+{ 424, 361, 316, 300, 361, 283, 224, 200, 316, 224, 141, 100, 300, 200, 100, 0 },
+}, @readonly: true);
+    internal static readonly DoubleMatrix Coordinates = new DoubleMatrix(new double[,] {
+{ 100, 100 }, { 100, 200 }, { 100, 300 }, { 100, 400 },
+{ 200, 100 }, { 200, 200 }, { 200, 300 }, { 200, 400 },
+{ 300, 100 }, { 300, 200 }, { 300, 300 }, { 300, 400 },
+{ 400, 100 }, { 400, 200 }, { 400, 300 }, { 400, 400 }
+}, @readonly: true);
+    internal static readonly PercentArray Probabilities = new PercentArray(new double[] {
+0.2, 0.3, 0.4, 0.5, 0.6, 0.7, 0.8, 0.7, 0.6, 0.5, 0.4, 0.3, 0.2, 0.3, 0.4, 0.5
+}, @readonly: true);
+    internal static readonly string Name = "HL PTSP Default";
+  }
+}
Index: /branches/2521_ProblemRefactoring/HeuristicLab.Problems.PTSP/3.3/Plugin.cs.frame
===================================================================
--- /branches/2521_ProblemRefactoring/HeuristicLab.Problems.PTSP/3.3/Plugin.cs.frame	(revision 17252)
+++ /branches/2521_ProblemRefactoring/HeuristicLab.Problems.PTSP/3.3/Plugin.cs.frame	(revision 17253)
@@ -38,4 +38,5 @@
   [PluginDependency("HeuristicLab.Attic", "1.0")]
   [PluginDependency("HeuristicLab.Problems.Instances", "3.3")]
+  [PluginDependency("HeuristicLab.Problems.TravelingSalesman", "3.3")]
   [PluginDependency("HeuristicLab.Random", "3.3")]
   public class HeuristicLabProblemsPTSPPlugin : PluginBase {
Index: /branches/2521_ProblemRefactoring/HeuristicLab.Problems.QuadraticAssignment/3.3/QuadraticAssignmentProblem.cs
===================================================================
--- /branches/2521_ProblemRefactoring/HeuristicLab.Problems.QuadraticAssignment/3.3/QuadraticAssignmentProblem.cs	(revision 17252)
+++ /branches/2521_ProblemRefactoring/HeuristicLab.Problems.QuadraticAssignment/3.3/QuadraticAssignmentProblem.cs	(revision 17253)
@@ -177,4 +177,5 @@
     protected override void OnEncodingChanged() {
       base.OnEncodingChanged();
+      Encoding.Length = Weights.Rows;
       Parameterize();
     }
Index: /branches/2521_ProblemRefactoring/HeuristicLab.Problems.TravelingSalesman/3.3/TSP.cs
===================================================================
--- /branches/2521_ProblemRefactoring/HeuristicLab.Problems.TravelingSalesman/3.3/TSP.cs	(revision 17252)
+++ /branches/2521_ProblemRefactoring/HeuristicLab.Problems.TravelingSalesman/3.3/TSP.cs	(revision 17253)
@@ -72,7 +72,10 @@
 
       TSPData = new EuclideanTSPData();
+      Encoding.Length = TSPData.Cities;
 
       InitializeOperators();
     }
+
+    // TODO: encoding length should not be changeable
 
     public override IDeepCloneable Clone(Cloner cloner) {
@@ -99,13 +102,21 @@
         i = qualities.Select((x, index) => new { index, Fitness = x }).OrderBy(x => x.Fitness).First().index;
       else i = qualities.Select((x, index) => new { index, Fitness = x }).OrderByDescending(x => x.Fitness).First().index;
-      var solution = TSPData.GetSolution(solutions[i], qualities[i]);
 
       if (double.IsNaN(BestKnownQuality) ||
           Maximization && qualities[i] > BestKnownQuality ||
           !Maximization && qualities[i] < BestKnownQuality) {
+        var bestKnown = TSPData.GetSolution(solutions[i], qualities[i]);
         BestKnownQualityParameter.Value = new DoubleValue(qualities[i]);
-        BestKnownSolutionParameter.Value = solution;
-      }
-      results.AddOrUpdateResult("Best TSP Solution", solution);
+        BestKnownSolutionParameter.Value = bestKnown;
+      }
+
+      IResult bestSolutionResult;
+      if (results.TryGetValue("Best TSP Solution", out bestSolutionResult)) {
+        var bestSolution = bestSolutionResult.Value as ITSPSolution;
+        if (bestSolution == null || Maximization && bestSolution.TourLength.Value < qualities[i]
+          || !Maximization && bestSolution.TourLength.Value > qualities[i]) {
+          bestSolutionResult.Value = TSPData.GetSolution(solutions[i], qualities[i]);
+        }
+      } else results.Add(new Result("Best TSP Solution", TSPData.GetSolution(solutions[i], qualities[i])));
     }
 
@@ -132,8 +143,5 @@
       Description = data.Description;
 
-      if (data.DistanceMeasure == DistanceMeasure.Att
-        || data.DistanceMeasure == DistanceMeasure.Manhattan
-        || data.DistanceMeasure == DistanceMeasure.Maximum
-        || data.Dimension <= DistanceMatrixSizeLimit) {
+      if (data.Dimension <= DistanceMatrixSizeLimit) {
         TSPData = new MatrixTSPData(data.Name, data.GetDistanceMatrix(), data.Coordinates) { Description = data.Description };
       } else if (data.DistanceMeasure == DistanceMeasure.Direct && data.Distances != null) {
@@ -141,4 +149,7 @@
       } else {
         switch (data.DistanceMeasure) {
+          case DistanceMeasure.Att:
+            TSPData = new AttTSPData(data.Name, data.Coordinates) { Description = data.Description };
+            break;
           case DistanceMeasure.Euclidean:
             TSPData = new EuclideanTSPData(data.Name, data.Coordinates, EuclideanTSPData.DistanceRounding.None) { Description = data.Description };
@@ -152,4 +163,10 @@
           case DistanceMeasure.Geo:
             TSPData = new GeoTSPData(data.Name, data.Coordinates) { Description = data.Description };
+            break;
+          case DistanceMeasure.Manhattan:
+            TSPData = new ManhattanTSPData(data.Name, data.Coordinates) { Description = data.Description };
+            break;
+          case DistanceMeasure.Maximum:
+            TSPData = new MaximumTSPData(data.Name, data.Coordinates) { Description = data.Description };
             break;
           default:
@@ -185,6 +202,8 @@
     }
 
+
     protected override void OnEncodingChanged() {
       base.OnEncodingChanged();
+      Encoding.Length = TSPData.Cities;
       ParameterizeOperators();
     }
Index: /branches/2521_ProblemRefactoring/HeuristicLab.Problems.TravelingSalesman/3.3/TSPData.cs
===================================================================
--- /branches/2521_ProblemRefactoring/HeuristicLab.Problems.TravelingSalesman/3.3/TSPData.cs	(revision 17252)
+++ /branches/2521_ProblemRefactoring/HeuristicLab.Problems.TravelingSalesman/3.3/TSPData.cs	(revision 17253)
@@ -31,4 +31,6 @@
   [StorableType("1a9bf60c-b6a6-4c95-8e99-5a2dec0ee892")]
   public interface ITSPData : INamedItem {
+    int Cities { get; }
+
     double GetDistance(int fromCity, int toCity);
     ITSPSolution GetSolution(Permutation tspTour, double tourLength);
@@ -38,11 +40,13 @@
   [Item("Matrix-based TSP Data", "TSP that is representd by a distance matrix.")]
   [StorableType("4df58a35-679d-4414-b815-9450ae100823")]
-  public sealed class MatrixTSPData : NamedItem, ITSPData {
-    [Storable] public DoubleMatrix Matrix { get; private set; }
-    [Storable] public DoubleMatrix DisplayCoordinates { get; private set; }
-
-    [StorableConstructor]
-    private MatrixTSPData(StorableConstructorFlag _) : base(_) { }
-    private MatrixTSPData(MatrixTSPData original, Cloner cloner) : base(original, cloner) {
+  public class MatrixTSPData : NamedItem, ITSPData {
+    [Storable] public DoubleMatrix Matrix { get; protected set; }
+    [Storable] public DoubleMatrix DisplayCoordinates { get; protected set; }
+
+    public int Cities => Matrix.Rows;
+
+    [StorableConstructor]
+    protected  MatrixTSPData(StorableConstructorFlag _) : base(_) { }
+    protected MatrixTSPData(MatrixTSPData original, Cloner cloner) : base(original, cloner) {
       Matrix = original.Matrix;
       DisplayCoordinates = original.DisplayCoordinates;
@@ -68,9 +72,9 @@
         throw new ArgumentException("Unequal number of rows in " + nameof(matrix) + " and " + nameof(coordinates) + ".");
       Name = name;
-      Matrix = (DoubleMatrix)matrix.AsReadOnly();
-      DisplayCoordinates = (DoubleMatrix)coordinates?.AsReadOnly();
-    }
-
-    public ITSPSolution GetSolution(Permutation tour, double tourLength) {
+      Matrix = matrix.AsReadOnly();
+      DisplayCoordinates = coordinates?.AsReadOnly();
+    }
+
+    public virtual ITSPSolution GetSolution(Permutation tour, double tourLength) {
       return new TSPSolution(DisplayCoordinates, tour, new DoubleValue(tourLength));
     }
@@ -97,5 +101,7 @@
   [StorableType("3955d07a-d43c-4a01-9505-d2effb1ea865")]
   public abstract class CoordinatesTSPData : NamedItem, ITSPData {
-    [Storable] public DoubleMatrix Coordinates { get; private set; }
+    [Storable] public DoubleMatrix Coordinates { get; protected set; }
+
+    public int Cities => Coordinates.Rows;
 
     [StorableConstructor]
@@ -118,5 +124,5 @@
       if (coordinates.Columns != 2) throw new ArgumentException("Argument must have exactly two columns.", nameof(coordinates));
       Name = name;
-      Coordinates = (DoubleMatrix)coordinates.AsReadOnly();
+      Coordinates = coordinates.AsReadOnly();
     }
 
@@ -128,5 +134,5 @@
     public abstract double GetDistance(double fromX, double fromY, double toX, double toY);
 
-    public ITSPSolution GetSolution(Permutation tour, double tourLength) {
+    public virtual ITSPSolution GetSolution(Permutation tour, double tourLength) {
       return new TSPSolution(Coordinates, tour, new DoubleValue(tourLength));
     }
@@ -137,13 +143,13 @@
   [Item("Euclidean TSP Data", "TSP that is represented by coordinates in an Euclidean plane.")]
   [StorableType("4bf58348-cd98-46c5-a4c0-55f486ca88b4")]
-  public sealed class EuclideanTSPData : CoordinatesTSPData {
+  public class EuclideanTSPData : CoordinatesTSPData {
     public enum DistanceRounding { None, Midpoint, Ceiling }
 
     [Storable]
-    public DistanceRounding Rounding { get; private set; }
-
-    [StorableConstructor]
-    private EuclideanTSPData(StorableConstructorFlag _) : base(_) { }
-    private EuclideanTSPData(EuclideanTSPData original, Cloner cloner) : base(original, cloner) {
+    public DistanceRounding Rounding { get; protected set; }
+
+    [StorableConstructor]
+    protected EuclideanTSPData(StorableConstructorFlag _) : base(_) { }
+    protected EuclideanTSPData(EuclideanTSPData original, Cloner cloner) : base(original, cloner) {
       Rounding = original.Rounding;
     }
@@ -166,5 +172,5 @@
 
     public override double GetDistance(double fromX, double fromY, double toX, double toY) {
-      var dist = Math.Sqrt((fromX - toX) * (fromX - toX) + (fromY - toY) * (fromY - toY));
+      var dist = DistanceHelper.EuclideanDistance(fromX, fromY, toX, toY);
       switch (Rounding) {
         case DistanceRounding.None: return dist;
@@ -193,11 +199,8 @@
   [Item("Geo TSP Data", "TSP that is represented by geo coordinates.")]
   [StorableType("4bf58348-cd98-46c5-a4c0-55f486ca88b4")]
-  public sealed class GeoTSPData : CoordinatesTSPData {
-    public const double PI = 3.141592;
-    public const double RADIUS = 6378.388;
-
-    [StorableConstructor]
-    private GeoTSPData(StorableConstructorFlag _) : base(_) { }
-    private GeoTSPData(GeoTSPData original, Cloner cloner) : base(original, cloner) { }
+  public class GeoTSPData : CoordinatesTSPData {
+    [StorableConstructor]
+    protected GeoTSPData(StorableConstructorFlag _) : base(_) { }
+    protected GeoTSPData(GeoTSPData original, Cloner cloner) : base(original, cloner) { }
     public GeoTSPData() : base() { }
     public GeoTSPData(string name, double[,] coordinates) : base(name, coordinates) { }
@@ -209,23 +212,5 @@
 
     public override double GetDistance(double fromX, double fromY, double toX, double toY) {
-      double latitude1, longitude1, latitude2, longitude2;
-      double q1, q2, q3;
-      double length;
-
-      latitude1 = ConvertToRadian(fromX);
-      longitude1 = ConvertToRadian(fromY);
-      latitude2 = ConvertToRadian(toX);
-      longitude2 = ConvertToRadian(toY);
-
-      q1 = Math.Cos(longitude1 - longitude2);
-      q2 = Math.Cos(latitude1 - latitude2);
-      q3 = Math.Cos(latitude1 + latitude2);
-
-      length = (int)(RADIUS * Math.Acos(0.5 * ((1.0 + q1) * q2 - (1.0 - q1) * q3)) + 1.0);
-      return (length);
-    }
-
-    private double ConvertToRadian(double x) {
-      return PI * (Math.Truncate(x) + 5.0 * (x - Math.Truncate(x)) / 3.0) / 180.0;
+      return DistanceHelper.GeoDistance(fromX, fromY, toX, toY);
     }
 
@@ -237,4 +222,91 @@
         Dimension = Coordinates.Rows,
         DistanceMeasure = DistanceMeasure.Geo
+      };
+    }
+  }
+
+  [Item("ATT TSP Data", "TSP that is represented by ATT coordinates.")]
+  [StorableType("d7a0add3-6ec1-42e0-b1d7-b6454694d485")]
+  public class AttTSPData : CoordinatesTSPData {
+    [StorableConstructor]
+    protected AttTSPData(StorableConstructorFlag _) : base(_) { }
+    protected AttTSPData(AttTSPData original, Cloner cloner) : base(original, cloner) { }
+    public AttTSPData() : base() { }
+    public AttTSPData(string name, double[,] coordinates) : base(name, coordinates) { }
+    public AttTSPData(string name, DoubleMatrix coordinates) : base(name, coordinates) { }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new AttTSPData(this, cloner);
+    }
+
+    public override double GetDistance(double fromX, double fromY, double toX, double toY) {
+      return DistanceHelper.AttDistance(fromX, fromY, toX, toY);
+    }
+
+    public override TSPData Export() {
+      return new TSPData() {
+        Name = name,
+        Description = description,
+        Coordinates = Coordinates.CloneAsMatrix(),
+        Dimension = Coordinates.Rows,
+        DistanceMeasure = DistanceMeasure.Att
+      };
+    }
+  }
+
+  [Item("Manhattan TSP Data", "TSP that is represented by Manhattan coordinates.")]
+  [StorableType("5f1ef9e2-cbd1-400e-8f87-6855f091fc9e")]
+  public class ManhattanTSPData : CoordinatesTSPData {
+    [StorableConstructor]
+    protected ManhattanTSPData(StorableConstructorFlag _) : base(_) { }
+    protected ManhattanTSPData(ManhattanTSPData original, Cloner cloner) : base(original, cloner) { }
+    public ManhattanTSPData() : base() { }
+    public ManhattanTSPData(string name, double[,] coordinates) : base(name, coordinates) { }
+    public ManhattanTSPData(string name, DoubleMatrix coordinates) : base(name, coordinates) { }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new ManhattanTSPData(this, cloner);
+    }
+
+    public override double GetDistance(double fromX, double fromY, double toX, double toY) {
+      return DistanceHelper.ManhattanDistance(fromX, fromY, toX, toY);
+    }
+
+    public override TSPData Export() {
+      return new TSPData() {
+        Name = name,
+        Description = description,
+        Coordinates = Coordinates.CloneAsMatrix(),
+        Dimension = Coordinates.Rows,
+        DistanceMeasure = DistanceMeasure.Manhattan
+      };
+    }
+  }
+
+  [Item("Manhattan TSP Data", "TSP that is represented by the maximum absolute distance in either x or y coordinates.")]
+  [StorableType("c6294a6c-fe62-4906-9765-4bc306d3e4a8")]
+  public class MaximumTSPData : CoordinatesTSPData {
+    [StorableConstructor]
+    protected MaximumTSPData(StorableConstructorFlag _) : base(_) { }
+    protected MaximumTSPData(MaximumTSPData original, Cloner cloner) : base(original, cloner) { }
+    public MaximumTSPData() : base() { }
+    public MaximumTSPData(string name, double[,] coordinates) : base(name, coordinates) { }
+    public MaximumTSPData(string name, DoubleMatrix coordinates) : base(name, coordinates) { }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new MaximumTSPData(this, cloner);
+    }
+
+    public override double GetDistance(double fromX, double fromY, double toX, double toY) {
+      return DistanceHelper.MaximumDistance(fromX, fromY, toX, toY);
+    }
+
+    public override TSPData Export() {
+      return new TSPData() {
+        Name = name,
+        Description = description,
+        Coordinates = Coordinates.CloneAsMatrix(),
+        Dimension = Coordinates.Rows,
+        DistanceMeasure = DistanceMeasure.Maximum
       };
     }
